
using Toybox.Background as Bg;
using Toybox.System as Sys;
using Toybox.Communications as Comms;
using Toybox.Application as App;

(:background)
class BackgroundService extends Sys.ServiceDelegate {
	
	var deviceInformation;
	var PATH = "0_8_0";
	var APP_VERSION = "0.9.6";
	
	(:background_method)
	function initialize() {
		System.println("initialize backgroundMethod");
		Sys.ServiceDelegate.initialize();
	} 

	// Read pending web requests, and call appropriate web request function.
	// This function determines priority of web requests, if multiple are pending.
	// Pending web request flag will be cleared only once the background data has been successfully received.
	(:background_method)
	function onTemporalEvent() {
		

		System.println("launch temporalEvent");

		//This is a fake link, just to prove it works... Replace this link by your own link server
		var URL = "https://run.mocky.io/v3/e2f4ed99-6092-47c1-8a00-ac5d7c681ed2";
		System.println(URL);
		//Sys.println("onTemporalEvent");
		var pendingWebRequests = App.getApp().getProperty("PendingWebRequests");
		if (pendingWebRequests != null) {

			if (pendingWebRequests["ikigaiStatus"] != null){
			//var st = new SystemOut("Launch a request with the attempt " + attemptPost,4,1);
    			
		    	//timerWithNoGPS.stop();
		       	var locUrl = URL;                         // set the url
			   	var locDeviceInformation = new DeviceInformation();
			    
			    var key =  "hell yeah !";
			   
		       	var jsonParams = { 
		       		  "key" => key,                                             // set the parameters
		              "calories0" => locDeviceInformation.calories[0],
		              "calories1" => locDeviceInformation.calories[1],
		              "calories2" => locDeviceInformation.calories[2],
		              "calories3" => locDeviceInformation.calories[3],
		              "calories4" => locDeviceInformation.calories[4],
		              "calories5" => locDeviceInformation.calories[5],
		              "calories6" => locDeviceInformation.calories[6],
		              "floorsClimbed0" => locDeviceInformation.floorsClimbed[0],
		              "floorsClimbed1" => locDeviceInformation.floorsClimbed[1],
		              "floorsClimbed2" => locDeviceInformation.floorsClimbed[2],
		              "floorsClimbed3" => locDeviceInformation.floorsClimbed[3],
		              "floorsClimbed4" => locDeviceInformation.floorsClimbed[4],
		              "floorsClimbed5" => locDeviceInformation.floorsClimbed[5],
		              "floorsClimbed6" => locDeviceInformation.floorsClimbed[6],
		              "steps0" => locDeviceInformation.steps[0],
		              "steps1" => locDeviceInformation.steps[1],
		              "steps2" => locDeviceInformation.steps[2],
		              "steps3" => locDeviceInformation.steps[3],
		              "steps4" => locDeviceInformation.steps[4],
		              "steps5" => locDeviceInformation.steps[5],
		              "steps6" => locDeviceInformation.steps[6],
		              "dateTime" => locDeviceInformation.dateTime,
		              "dateTimeUtc" => locDeviceInformation.dateTimeUtc,
		              "birthYear" => locDeviceInformation.birthYear,
		              "gender" => locDeviceInformation.gender,
		              "weight" => locDeviceInformation.weight,
		              "height" => locDeviceInformation.height,
		              "weightUnit" => locDeviceInformation.weightUnit,
		              "heightUnit" => locDeviceInformation.heightUnit,
		              "deviceId" => locDeviceInformation.deviceId,
		              "deviceType" => locDeviceInformation.deviceType,
		              "screenWidth" => locDeviceInformation.screenWidth,
		              "screenHeight" => locDeviceInformation.screenHeight,
		              "locationX" => 0,
		              "locationY" => 0,
		              "language" => locDeviceInformation.language,
					  "versionIkigai"=>APP_VERSION,
					  "nbrFailedConnectionWithoutInit"=>App.getApp().getProperty("nbrFailedConnectionWithoutInit"),
					  "nbrFailedConnection"=>App.getApp().getProperty("nbrFailedConnection")
				};
		       
		       	System.println("launch - nbrFailedConnectionWithoutInit " + App.getApp().getProperty("nbrFailedConnectionWithoutInit"));
		      	System.println("launch - nbrFailedConnection " +App.getApp().getProperty("nbrFailedConnection"));
		   
		       	var POST_OPTIONS = {                                             // set the options
		           :method => Communications.HTTP_REQUEST_METHOD_POST,      // set HTTP method 
		           :headers => {"Content-Type" => Communications.REQUEST_CONTENT_TYPE_JSON},
		       };
		
				System.println("Envoi au server");
		   		Communications.cancelAllRequests();
		   		Communications.makeWebRequest(URL, jsonParams, POST_OPTIONS, method(:onReceive));
				jsonParams = null;
			
			
			}
		} 
		// else {Sys.println("onTemporalEvent() called with no pending web requests!");} 
		
	}

	
	
	
	(:background_method)
	function onReceive(parResponseCode,parArgs) {
		System.println("reception du code : " + parArgs);
        if (parArgs == null || parArgs instanceof Lang.String) {
        	//var st = new SystemOut("Réception du JSON" + parArgs,2,1);
        	Bg.exit({
				"ikigaiStatus" => null
			});
        }
        else if (parArgs instanceof Dictionary) {
        // regenerate a new emptyObjecti
        
            var app = Application.getApp();
		/*	app.setProperty("JSON", parArgs);  
			parArgs = null;
			
       		UtilsBg.treatJSON(app.getProperty("JSON"));
            hasReceivedJSON = true;
    		//var st3 = new SystemOut("Fin du traitement du JSON" + parArgs,3,1);
    		//st3 = new SystemOut("Enregistrement du JSON" + parArgs,3,1);
    		
    		//store the new value
            Utils.getImages();*/

			var result = treatJSON(parArgs);
            Bg.exit({
				"ikigaiStatus" => result
			});
        }    
    }
    
    
    
    function treatJSON(parJSON)
    {
    	System.println("JSON : " + parJSON);
    	var locKeys = parJSON.keys();
        var result = null;
        for( var i = 0; i < locKeys.size(); i++ ) {
        	//message = Lang.format("=> $1$: $2$\n", [locKeys[i], locKeys[i][locKeys[i]]]);
        	System.println("Examine : " + locKeys[i]);
        	if (locKeys[i].equals("ikigaisStatus")){
        		//var st2 = new SystemOut("Traitement du JSON  : " + locKeys[i]+ " " + parJSON[locKeys[i]],5,1);
        		var JSONIkigaiStatus = parJSON[locKeys[i]];
		    	var message;
		        var locKeys = JSONIkigaiStatus.keys();
		        message = "";
		        for( var i = 0; i < locKeys.size(); i++ ) {
	        		var j = i+1;
	            	//message = Lang.format("-- $1$: $2$\n", [locKeys[i], JSONIkigaiStatus[locKeys[i]]]);
	
	            	if (locKeys[i].equals("ikigais")){
		            	System.println("Treat : ikigais");
	            	    result = treatIkigais(JSONIkigaiStatus[locKeys[i]]);
	            	}
		        }
		    }
	/*	    if (locKeys[i].equals("dico")){
		    	//var st = new SystemOut("dico:",5,1);
		    	//ikigaisStatus.dico = parJSON[locKeys[i]];
		    	System.println("l1 " + result["level"]);
		    	System.println("l2 " + parJSON[locKeys[i]].get("level"));
		    	
		    	//result["level"] = parJSON[locKeys[i]].get("level") + " " + result["level"] ;
		    }*/
		    
		}
		return result;
		
        
    }


    
    function treatIkigais(parJSON)
    {
    		var message;
    		var result = null;
            for( var i = 0; i < parJSON.size(); i++ ) {
            		            	System.println("Treat : " + i);
            		var j = i+1;
            		var locJSONIkigai = parJSON[i];
                	//message = Lang.format("--" + j + ") $1$ \n", [parJSON[i], ]);
                	//var st = new SystemOut(message,6,1);
       
 					
                	var locName =locJSONIkigai.get("name");
                	//st = new SystemOut("----name:" + locName,6,1);
                	var locState= locJSONIkigai.get("state");
                	//st = new SystemOut("----state:" + locState,6,1);
                	var locLevel=locJSONIkigai.get("level");
                	//st = new SystemOut("----level:" + locLevel,6,1);
                	var locLife = locJSONIkigai.get("life");
                	//st = new SystemOut("----life:" + locLife,6,1);
                	//var locLevelPerc = locJSONIkigai.get("levelPerc");
                	//st = new SystemOut("----levelPerc:" + locLevelPerc,6,1);
                	//var locEnergy= locJSONIkigai.get("energy");
                	//st = new SystemOut("----energy:" + locEnergy,6,1);
                	//var locEnergyPerc= locJSONIkigai.get("energyPerc");
                	//st = new SystemOut("----energyPerc:" + locEnergyPerc,6,1);
                	var locStateName= locJSONIkigai.get("stateName");
                	//st = new SystemOut("----stateName:" + locStateName,6,1);

 					
                	//var locLastState= locJSONIkigai.get("lastState");
                	//st = new SystemOut("----lastState:" + locLastState,6,1);
                	//var locLastLevel=locJSONIkigai.get("lastLevel");
                	//st = new SystemOut("----lastLevel:" + locLastLevel,6,1);
                	//var locLastLife = locJSONIkigai.get("lastLife");
                	//st = new SystemOut("----lastLife:" + locLastLife,6,1);
                	//var locLastLevelPerc = locJSONIkigai.get("lastLevelPerc");
                	//st = new SystemOut("----lastLevelPerc:" + locLastLevelPerc,6,1);
                	//var locLastEnergy= locJSONIkigai.get("lastEnergy");
                	//st = new SystemOut("----lastEnergy:" + locLastEnergy,6,1);
                	//var locLastEnergyPerc= locJSONIkigai.get("lastEnergyPerc");
                	//st = new SystemOut("----lastEnergyPerc:" + locLastEnergyPerc,6,1);     
                	//var locLastStateName= locJSONIkigai.get("lastStateName");
                	//st = new SystemOut("----stateName:" + locLastStateName,6,1);  
                	
                	       						
					
                	var locImageType = locJSONIkigai.get("imageType");
                	/*if (locJSONIkigai.get("typeForm") != null) {
                		locTypeForm= locTypeForm.get("typeForm");
                	} else { //masc = B and femin = A
	                	var locProfile = UserProfile.getProfile();
	                	if (locProfile.gender == 0) {
	                		locTypeForm = "A";
				        }  else {
				            locTypeForm = "B";
				        }
	                	
                	}*/

					//Km Equiv------------
					/*var locKmEquiv = new[8];
					for( var j = 0; j < 8; j++ ){
						locKmEquiv[j] = 0.0;
	                }
	                	
                	if (locJSONIkigai.get("kmEquiv") != null)
                	{
                		for( var i = 0; i < locJSONIkigai.get("kmEquiv").size()&&i<8; i++ )
                		{
                			locKmEquiv[i] = locJSONIkigai.get("kmEquiv")[i];
                			//st = new SystemOut("----KmEquiv[:" + i +"] = " +locKmEquiv[i] ,6,1);
                		}
                	} */
                						
                	var locKmEquivToday = locJSONIkigai.get("kmEquiv")[0];
				
					//var locKmEquivTotal = locJSONIkigai.get("kmEquivTotal");
					//if (locKmEquivTotal == null) {locKmEquivTotal = "2381";}
					//st = new SystemOut("----KmEquivTotal = " +locKmEquivTotal ,6,1);
					
					//var locLastKmEquivTotal = locJSONIkigai.get("lastKmEquivTotal");
					//if (locLastKmEquivTotal == null) {locLastKmEquivTotal = "2345";}
					//st = new SystemOut("----LastKmEquivTotal = " +locLastKmEquivTotal ,6,1);
					
					//var locKmEquivProgression = locJSONIkigai.get("kmEquivProgression");
					//if (locKmEquivProgression == null) {locKmEquivProgression = "+15% than avg";}
					//st = new SystemOut("----KmEquivProgression = " +locKmEquivProgression ,6,1);
					
					//var locKmEquivForLastWeek = locJSONIkigai.get("kmEquivForLastWeek");
					//if (locKmEquivForLastWeek == null) {locKmEquivForLastWeek = "36";}
					//st = new SystemOut("----kmEquivTotal = " +locKmEquivForLastWeek ,6,1);
		
		
					var locKmEqUnit = locJSONIkigai.get("kmEqUnit");
                	//st = new SystemOut("----KmEqUnit = " +locKmEqUnit ,6,1);
                	
                    //st = new SystemOut("----Events:",6,1);
                	//var locEvents = treatEvents(locJSONIkigai.get("events"));
            		
                	//st = new SystemOut("----lifeLogs:",6,1);
                	//System.println("-----LifeLogs");
                	//var locLifeLogs = treatLifeLogs(locJSONIkigai.get("lifeLogs"));
                	
                	//st = new SystemOut("----insert Ikigai:",6,1);
                	//System.println("--Insert Ikigai:"); 
                	//var basicInformation = {"name"=>locName,"state"=>locState, "level"=>locLevel,"life"=>locLife,"levelPerc"=>locLevelPerc,"energy"=>locEnergy, "energyPerc"=>locEnergyPerc,"stateName"=>locStateName,"lastState"=>locLastState, "lastLevel"=>locLastLevel,"lastLife"=>locLastLife,"lastLevelPerc"=>locLastLevelPerc,"lastEnergy"=>locLastEnergy, "lastEnergyPerc"=>locLastEnergyPerc,"lastStateName"=>locLastStateName,"kmEquivTotal"=>locKmEquivTotal,"lastKmEquivTotal"=>locLastKmEquivTotal,"kmEquivProgression"=>locKmEquivProgression,"kmEquivForLastWeek"=>locKmEquivForLastWeek,"kmEqUnit"=>locKmEqUnit,"imageType"=>locImageType};
                	
					//locIkigais[i] = new Ikigai(basicInformation, locKmEquiv,locLifeLogs);
					
					result = {
						"level" => "Level " + locLevel,
						"userName" => locName,
						"state" => locState,
						"nameEvolution"=>locStateName,
						"ikiboost" => locLife,
						"type"=>locImageType,
						"kmEquivToday"=> locKmEquivToday,
						"kmEqUnit"=>locKmEqUnit
					};
					

            }
            return result;
    }
    
	
}



    	
