using Toybox.UserProfile;
using Toybox.WatchUi;
using Toybox.Application as App;

(:background)
class DeviceInformation {

		var calories = new[7];
		var floorsClimbed = new[7];
		var steps = new[7];
		var dateTime;
		var dateTimeUtc;
		var birthYear;
		var gender;
		var weight;
		var height;
		var weightUnit;
		var heightUnit; 
		var deviceId;
		var deviceType;
		var screenWidth;
		var screenHeight;
		var language; 

    (:background_method)
    function initialize() {

        System.println("Initialisation de la recherche d'information ");
    
		var locHist;
		var locProfile;
		var locSettings;
		var locCalories = new[7];
		var locFloorsClimbed = new[7];
		var locSteps = new[7];
		var locBirthYear ;
        var locWeight  ;
        var locHeight  ;
		var locWeightUnit;
		var locHeightUnit ;   
		var locGender;
    	var locDateTime;
    	var locDeviceId;
		var locDeviceType;
		var locScreenWidth;
		var locScreenHeight;
		var locLanguage="fr";
	
			
    	//Insert fake data*****************
    	for (var i = 0; i <7; i++) {
			locCalories[i] = 999;
		}
		for (var i = 0; i <7; i++) {
			locFloorsClimbed[i] = 0;
		}
		for (var i = 0; i <7; i++) {
			locSteps[i] = 999;
		}
		var locDateTimeUtc = (new Time.Moment(Time.now().value())).value();
		//System.println("localtimeUtc : " + locDateTimeUtc);
		locDateTime = locDateTimeUtc + System.getClockTime().timeZoneOffset;
        //System.println("localtime : " + locDateTime);

		
		locBirthYear = 999;
		locWeight = 888;
		locHeight = 999;
		locWeightUnit = "m";
		locHeightUnit = "m";
		locGender = "b";
		locDeviceId = "XXXXXXXXv2";
		locDeviceType = "forrunner945";
		locScreenWidth = "999";
		locScreenHeight = "888"; 
    	
    	
    	//Override with the good data*********************
    	locHist = ActivityMonitor.getHistory();
    	locProfile = UserProfile.getProfile();
		locSettings = System.getDeviceSettings();
		
    	var locInfo = ActivityMonitor.getInfo();
  		locCalories[0] = locInfo.calories;
  		if (locCalories[0] == null){
  			locCalories[0] = 998;
  		}
    	for (var i = 0; i < locHist.size() && i <6; i++) {
    		locCalories[i+1] = locHist[i].calories;
    	}
    	
    	locLanguage = App.getApp().getProperty("language");
    	//st = new SystemOut("language : " + locLanguage,8,2);
    	
    	var locHasFloors = App.getApp().getProperty("hasFloors");
    	
    	if (locHasFloors.equals("true")){
	    	locFloorsClimbed[0] = locInfo.floorsClimbed;
	
	    	for (var i = 0; i < locHist.size() && i <6; i++) {
	    		locFloorsClimbed[i+1] = locHist[i].floorsClimbed;
	    	}
	    }else {
    		locFloorsClimbed[0] = 0;
    		for (var i = 0; i < locHist.size() && i <6; i++) {
	    		locFloorsClimbed[i+1] = 0;
	    	}
	    }
	    
    	locSteps[0] = locInfo.steps;
  		if (locSteps[0] == null){
  			locSteps[0] = 998;
  		}
    	for (var i = 0; i < locHist.size() && i <6; i++) {
    		locSteps[i+1] = locHist[i].steps;
    	}

    	
		locBirthYear = locProfile.birthYear.toString();
        locWeight =  locProfile.weight.toString() ;
        locHeight =  locProfile.height.toString() ;
		locWeightUnit = locSettings.weightUnits;
		locHeightUnit = locSettings.heightUnits;   
		
        locGender = "";
        if (locProfile.gender == 0) {
                locGender = "f";
        }
        else {
                locGender = "m";
        }
        
        var locHasUniqueIdentifier = App.getApp().getProperty("hasUniqueIdentifier");
        if (locHasUniqueIdentifier.equals("true")){
			locDeviceId = locSettings.uniqueIdentifier;
		}
		locDeviceType =  App.getApp().getProperty("garminDevice");
		System.println("My device is : " + locDeviceType);
		
		locScreenWidth;
		locScreenHeight;
		locScreenWidth = locSettings.screenWidth;
		locScreenHeight = locSettings.screenHeight;		
		
    	
		calories= locCalories;
		floorsClimbed = locFloorsClimbed;
		steps = locSteps;
		dateTime = locDateTime;
		dateTimeUtc = locDateTimeUtc;
		birthYear = locBirthYear;
		gender = locGender;
		weight = locWeight;
		height = locHeight;
		weightUnit = locWeightUnit;
		heightUnit = locHeightUnit;
		deviceId = locDeviceId;
		deviceType = locDeviceType;
		screenWidth = locScreenWidth;
		screenHeight = locScreenHeight;
		language = locLanguage;
		
   }
   

}