
using Toybox.Graphics;
using Toybox.ActivityMonitor;
using Toybox.Time;
using Toybox.System as System;
using Toybox.WatchUi as Ui;
using Toybox.Application as App;
using Toybox.Timer;
using Toybox.Attention;
using Toybox.Application.Storage;
using Toybox.Background as Bg;

using Toybox.Time.Gregorian;

class IkigaiDraw extends Ui.Drawable {


	var mIkigaiX;
	var mIkigaiY;
	
	
	var mNameEvolutionX;
	var mNameEvolutionY;
	var mLevelX;
	var mLevelY;
	var mIkiboostX;
	var mIkiboostY;
	var mHeartX;
	var mHeartY;
	var mUserNameX;
	var mUserNameY;
	var mWidthLoading;
	var mWatchIconX;
	var mWatchIconY;

	function initialize(params) {
		Drawable.initialize(params);

		onSettingsChanged();
		mIkigaiX = params[:ikigaiX];
		mIkigaiY = params[:ikigaiY];
		
		mNameEvolutionX = params[:nameEvolutionX];
		mNameEvolutionY = params[:nameEvolutionY];
		
		mLevelX = mNameEvolutionX;
		mLevelY = mNameEvolutionY + 25;
		
		mIkiboostX = mNameEvolutionX;
		mIkiboostY = mLevelY + 25;
		
		mHeartX = params[:heartX] + 45;
		mHeartY = mIkiboostY+12;
		
		mUserNameX = params[:nameUserX];
		mUserNameY = params[:nameUserY];
		
		mWidthLoading = params[:widthLoading];
		mWatchIconX = params[:watchIconX];
		mWatchIconY = params[:watchIconY];
	}

	function onSettingsChanged() {

	}

	function draw(dc) {
		var clockTime = System.getClockTime();
		var formattedTime = App.getApp().getFormattedTime(clockTime.hour, clockTime.min);
		System.println(formattedTime[:hour] + ":" + formattedTime[:min] + " : drawIkigai");
		
		var storedData = App.getApp().getProperty("ikigaiStatus");
		if (storedData == null) {
			
			if (Bg.getLastTemporalEventTime() == null){
				System.println("Pas de temporalEvent");
				return;
			}
			//var today = new Time.Moment(Time.now());

			//var todayvalue = today.value();
			//System.println(today.value()); //  86400, or one day in the future
			//System.println("NOW : " + todayvalue.value());
			var now = (new Time.Moment(Time.now())).value().value();
			//System.println("NOW : " + (new Time.Moment(Time.now())).value().value());
			//System.println("NOW : " + now);
			
			var lastTime = Bg.getLastTemporalEventTime().value();
			//System.println("lastTemporalEventTime : " + lastTime.value());
			//System.println("lastTemporalEventTime : " + lastTime);
			
			var minBeforeReloading = (300 + lastTime - now)/60;
			
			
			//NameEvolution
			//drawText(dc,"Will load\nyour Ikigai\nin less than\n" + minBeforeReloading + " min",dc.setColor(gMonoDarkColour, Toybox.Graphics.COLOR_TRANSPARENT),gNormalFont,mIkigaiX + 50,mIkigaiY,Graphics.TEXT_JUSTIFY_LEFT);
			
			
			drawLoading(dc, minBeforeReloading);
			
			
			return;
		}
		//System.println(storedData["userName"]);

		var stateToShow = storedData["state"];
		//Ikigai
		if(storedData["type"].equals("A"))
        {
	        if (stateToShow == 1){
	        	drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai1aSmall);
	    	} else if (stateToShow == 2){
	    		drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai2aSmall);
	    	} else if (stateToShow == 3){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai3aSmall);
	    	} else if (stateToShow == 4){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai4aSmall);
	    	} else if (stateToShow == 5){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai5aSmall);
	    	} else {
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai6aSmall);
	    	} 
	    } else if (storedData["type"].equals("C")){
	    	if (stateToShow == 1){
	        	drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai1cSmall);
	    	} else if (stateToShow == 2){
	    		drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai2cSmall);
	    	} else if (stateToShow == 3){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai3cSmall);
	    	} else if (stateToShow == 4){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai4cSmall);
	    	} else if (stateToShow == 5){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai5cSmall);
	    	} else {
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai6cSmall); 
	    	}
	    }else {
	    	if (stateToShow == 1){
	        	drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai1bSmall);
	    	} else if (stateToShow == 2){
	    		drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai2bSmall);
	    	} else if (stateToShow == 3){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai3bSmall);
	    	} else if (stateToShow == 4){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai4bSmall);
	    	} else if (stateToShow == 5){
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai5bSmall);
	    	} else {
		        drawBitmap(dc, mIkigaiX , mIkigaiY, Rez.Drawables.idIkigai6bSmall); 
	    	}
	    }
		
	
		//UserName
		drawText(dc,storedData["userName"],dc.setColor(gMonoDarkColour, Toybox.Graphics.COLOR_TRANSPARENT),gNormalFont,mUserNameX,mUserNameY,Graphics.TEXT_JUSTIFY_CENTER);
		
		//NameEvolution
		drawText(dc,storedData["nameEvolution"],dc.setColor(gMonoDarkColour, Toybox.Graphics.COLOR_TRANSPARENT),gNormalFont,mNameEvolutionX,mNameEvolutionY,Graphics.TEXT_JUSTIFY_LEFT);
	
		//Level
		drawText(dc,storedData["level"],dc.setColor(gMonoDarkColour, Toybox.Graphics.COLOR_TRANSPARENT),gNormalFont,mLevelX,mLevelY,Graphics.TEXT_JUSTIFY_LEFT);
	
		//Ikiboost
		//System.println("ikiboost" +  storedData["ikiboost"]);
		drawText(dc,storedData["ikiboost"].toString(),dc.setColor(gMonoDarkColour, Toybox.Graphics.COLOR_TRANSPARENT),gNormalFont,mIkiboostX,mIkiboostY,Graphics.TEXT_JUSTIFY_LEFT);
	
		dc.setColor(Graphics.COLOR_RED,Graphics.COLOR_BLACK);
		dc.drawText(
					mHeartX,
					mHeartY,
					gIconsFont,
					"3", // getIconFontCharForField(FIELD_TYPE_HR_LIVE_5S)
					Graphics.TEXT_JUSTIFY_CENTER | Graphics.TEXT_JUSTIFY_VCENTER
				);
		
				
	}
	
	function drawLoading(parDc, parMinBeforeReloading){
		drawBitmap(parDc, mWatchIconX , mWatchIconY, Rez.Drawables.idWatchIcon);
		drawBitmap(parDc, mWatchIconX+mWidthLoading-30 , mWatchIconY+2, Rez.Drawables.idPhoneIcon);
		
		//40 = width WatchIcon
		//30 = width phoneIcon
		//60 = height watchIcon
		//64 = height phoneIcon
		parDc.setColor(Graphics.COLOR_WHITE,Graphics.COLOR_WHITE);
		var dashProgress = mWatchIconX+40;
		while (dashProgress <(mWatchIconX+mWidthLoading-30)){
			drawLine(parDc,dashProgress, mWatchIconY+30, dashProgress+4, mWatchIconY+30);
			dashProgress = dashProgress+8;
		}
		parDc.setColor(Graphics.COLOR_RED,Graphics.COLOR_BLACK);
		drawText(parDc,"Loading...",parDc.setColor(Graphics.COLOR_RED,Graphics.COLOR_BLACK),gNormalFont,mWatchIconX+10,mWatchIconY-25,Graphics.TEXT_JUSTIFY_LEFT);
		drawText(parDc,"Ikigai in " + parMinBeforeReloading + " min",parDc.setColor(Graphics.COLOR_RED,Graphics.COLOR_BLACK),gNormalFont,mWatchIconX+10,mWatchIconY+65,Graphics.TEXT_JUSTIFY_LEFT);
	}
	
	function drawLine(parDc, parX1, parY1, parX2, parY2){
		var totalWidth = 240.0;
		var totalHeight = 240.0;
    	parDc.drawLine(Math.floor(parX1*totalWidth/240.0), Math.floor(parY1*totalHeight/240.0), Math.floor(parX2*totalWidth/240.0), Math.floor(parY2*totalHeight/240.0));
    }
    
    function drawBitmap(parDc, parX, parY, parRezId) {
   		var bitmap = new WatchUi.Bitmap({
			            :rezId=>parRezId,
			            :locX=>parX, 
			            :locY=>parY,
		});
		bitmap.draw(parDc);
		bitmap=null;
    }
    
    function drawText(parDc, parMessage, parColor, parFont, parX,parY,parJustification) {
   		var locX = Math.floor(parX);
   		var locY = Math.floor(parY);
        var text = new WatchUi.Text({
            :text=>parMessage,
            :color=>parColor,
            :font=>parFont,
            :locX =>locX,
            :locY=>locY
        });
        text.setJustification(parJustification);
        text.draw(parDc);
        text = null;  
    }
    
}
